-- Undertale Screensaver  by Daniel Kruger --
-- Website: http://www.cubecoded.com --

if arg[1] == "/p" then
	love.event.quit()
end

math.randomseed(os.time())
require "functions"
require "graphics"

love.mouse.setVisible(false)

modes = {"toriel","greaterdog","statue","castle","hotel","waterfall","napstablook","asriel","undynehouse"}
mode = modes[math.random(1,#modes)]
modemod = math.random(0,1)
-- mode = "undynehouse"

bounds = {}
bounds["toriel"] = {w=185/2,h=190}
bounds["greaterdog"] = {w=165/2,h=140}
bounds["asriel"] = {w=315/2,h=140}

spawndelay = {}
spawndelay["toriel"] = 0.1
spawndelay["statue"] = 0.2
spawndelay["hotel"] = 0.2
spawndelay["waterfall"] = 0.01
spawndelay["asriel"] = 0.1

namefont = love.graphics.newFont("Mars Needs Cunnilingus.ttf",24)
love.graphics.setFont(namefont)

debugmode = false
name = os.getenv("USERNAME")
name = string.sub(name,1,9)

player = {}
player.x = 0
player.y = 320

ent = {}
spawntick = 0
wagtick = 1
timepassed = 0
camx = 0
colortick = 0
colortick2 = 0
walktick = 0
walkframe = 1
streamy = 0
asrieltick = 0
asrielarmframe = 0
asrielbodyframe = 0
asrielorbframe = 0
asrielwingpos = 800
undynetick = 0
undyneframe = 0

if mode == "castle" then
	for f = 1,65 do
		table.insert(ent,{id="star",x=math.random(-320,320),y=math.random(20,120),frame=math.random(0,11),tick=0})
	end
end

streamx = {-1560/80/2*1.5,-8,0,5,1560/80/2*1.5}

spacedat = love.image.newImageData("graphics/space.png")
img.space = {}
id = {}
w = spacedat:getWidth()
h = spacedat:getHeight()
for y = 0,h-1 do
	id = love.image.newImageData(w,1)
	for x = 0,w-1 do
		r,g,b,a = spacedat:getPixel(x,y)
		id:setPixel(x,0,r,g,b,a)
	end
	img.space[y] = love.graphics.newImage(id)
end

wingquad = love.graphics.newQuad(0,0,800,600,1600,600)

function love.draw()
	
	-- boss --
	if mode == "toriel" then
		love.graphics.draw(img.toriel,resx()/2,46*scale(),0,scale()*2,scale()*2,img.toriel:getWidth()/2,0)
		
	elseif mode == "greaterdog" then
		love.graphics.draw(img.greaterdog_grid,math.floor(resx()/2),10*scale(),0,scale(),scale(),img.greaterdog_grid:getWidth()/2,0)
		if timepassed < 600 then
			love.graphics.draw(img["standingdog"..math.floor(wagtick)],math.floor(resx()/2),52*scale(),0,scale()*2,scale()*2,img.standingdog1:getWidth()/2,0)
		elseif timepassed < 1200 then
			love.graphics.draw(img["standingdog3"],math.floor(resx()/2),89*scale(),0,scale(),scale(),img.standingdog3:getWidth()/2,0)
		elseif timepassed < 1800 then
			love.graphics.draw(img["standingdog4"],math.floor(resx()/2),132*scale(),0,scale(),scale(),img.standingdog4:getWidth()/2,0)
		else
			love.graphics.draw(img["standingdog5"],math.floor(resx()/2),215*scale(),0,scale(),scale(),img.standingdog5:getWidth()/2,0)
		end
		
	elseif mode == "statue" then
		if modemod == 1 then
			love.graphics.draw(img.statue_umbrella,math.floor(resx()/2),0,0,scale()*2,scale()*2,img.statue:getWidth()/2,0)
			if timepassed > math.pi*1.7*100 then
				love.graphics.setColor(255,255,255,(math.cos(timepassed*1.7)+1)*255/2)
				love.graphics.draw(img.code,resx()/2+math.sin(timepassed)*10*scale(),(30+math.sin(timepassed*1.4)*5)*scale(),0,scale(),scale(),img.code:getWidth()/2,0)
				love.graphics.setColor(255,255,255)
			end
		else
			love.graphics.draw(img.statue,math.floor(resx()/2),0,0,scale()*2,scale()*2,img.statue:getWidth()/2,0)
		end
		
	elseif mode == "castle"  then
		love.graphics.draw(img.castle,math.floor(resx()/2),0,0,scale()*2,scale()*2,img.castle:getWidth()/2,0)
		
	elseif mode == "hotel" then
		love.graphics.draw(img.hotel,math.floor(resx()/2),0,0,scale()*2,scale()*2,img.hotel:getWidth()/2,0)
		
	elseif mode == "waterfall" then
		love.graphics.draw(img["frisk_umb_shadow"..walkframe],resx()/2,300*scale(),0,scale()*2,scale()*2,img.frisk_umb1:getWidth()/2,0)
		love.graphics.draw(img["kid_shadow"..walkframe],resx()/2-40*scale(),293*scale(),0,scale()*2,scale()*2,img.frisk_umb1:getWidth()/2,0)
		love.graphics.draw(img.waterfall,resx()/2-camx*scale(),0,0,scale()*2,scale()*2,0,0)
		love.graphics.draw(img.waterfall,resx()/2-(camx+1560)*scale(),0,0,scale()*2,scale()*2,0,0)
		love.graphics.draw(img["frisk_umb"..walkframe],resx()/2,220*scale(),0,scale()*2,scale()*2,img.frisk_umb1:getWidth()/2,0)
		love.graphics.draw(img["kid"..walkframe],resx()/2-40*scale(),240*scale(),0,scale()*2,scale()*2,img.frisk_umb1:getWidth()/2,0)
		
		for k,v in pairs (streamx) do
			for f = -1,resy()/scale()/60 do
				love.graphics.draw(img.waterstream,resx()/2+(v*80-camx*1.5)*scale(),(f*60+streamy)*scale(),0,scale(),scale(),0,0)
			end
		end
		
	elseif mode == "napstablook" then
		for f = 1,#img.space do
			love.graphics.draw(img.space[f],resx()/2+math.sin(timepassed/2+f/25)*12,f*2*scale(),0,2*scale(),2*scale(),img.space[f]:getWidth()/2,0)
		end
		love.graphics.draw(img.nap_house,resx()/2,0,0,scale()*2,scale()*2,img.nap_house:getWidth()/2,0)
		
	elseif mode == "asriel" then
		r = math.max(math.sin(colortick*math.pi*2/8*4/3),0)*255
		g = math.max(math.sin((colortick-1)*math.pi*2/8*4/3),0)*255
		b = math.max(math.sin((colortick+1)*math.pi*2/8*4/3),math.sin((colortick-3)*math.pi*2/8*4/3),0)*255
		love.graphics.setColor(r,g,b,170)
		wingquad:setViewport(asrielwingpos,0,800,600)
		love.graphics.draw(img.trippy,wingquad,resx()/2,0,0,scale(),scale(),0,0)
		love.graphics.draw(img.trippy,wingquad,resx()/2+50*scale(),0,0,scale(),scale(),0,0)
		love.graphics.draw(img.trippy,wingquad,resx()/2,0,0,-scale(),scale(),0,0)
		love.graphics.draw(img.trippy,wingquad,resx()/2-50*scale(),0,0,-scale(),scale(),0,0)
		
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill",resx()/2-45*scale(),0,90*scale(),250*scale())
		love.graphics.rectangle("fill",0,0,resx()/2-356*scale(),250*scale())
		love.graphics.rectangle("fill",resx()/2+356*scale(),0,resx()/2-356*scale(),250*scale())
		love.graphics.rectangle("fill",0,250*scale(),resx(),resy()-250*scale())
		
		love.graphics.setColor(255,255,255)
		love.graphics.draw(img.wing,resx()/2-356*scale(),-20*scale()+math.sin(timepassed*1.6)*4*scale(),0,2*scale(),2*scale(),0,0)
		love.graphics.draw(img.wing,resx()/2+356*scale(),-20*scale()+math.sin(timepassed*1.6)*4*scale(),0,-2*scale(),2*scale(),0,0)
		love.graphics.draw(img.asriel_face,resx()/2,6*scale(),0,2*scale(),2*scale(),img.asriel_face:getWidth()/2,0)
		love.graphics.draw(img["spr_afinal_orbwing_"..asrielarmframe],resx()/2-95*scale(),6*scale(),0,2*scale(),2*scale(),0,0)
		love.graphics.draw(img["spr_afinal_orbwing_"..asrielarmframe],resx()/2+95*scale(),6*scale(),0,-2*scale(),2*scale(),0,0)
		love.graphics.draw(img["spr_afinal_arm_"..asrielarmframe],resx()/2-75*scale(),103*scale(),0,2*scale(),2*scale(),0,0)
		love.graphics.draw(img["spr_afinal_arm_"..asrielarmframe],resx()/2+75*scale(),103*scale(),0,-2*scale(),2*scale(),0,0)
		love.graphics.draw(img["spr_afinal_shoulder_"..asrielarmframe],resx()/2-80*scale(),83*scale(),0,2*scale(),2*scale(),0,0)
		love.graphics.draw(img["spr_afinal_shoulder_"..asrielarmframe],resx()/2+80*scale(),83*scale(),0,-2*scale(),2*scale(),0,0)
		love.graphics.draw(img["spr_afinal_stem_"..asrielbodyframe],resx()/2,144*scale(),0,2*scale(),2*scale(),img.spr_afinal_stem_0:getWidth()/2,0)
		love.graphics.draw(img["spr_afinal_orb_"..asrielorbframe],resx()/2,86*scale(),0,2*scale(),2*scale(),img.spr_afinal_orb_0:getWidth()/2,0)
		
	elseif mode == "undynehouse" then
		love.graphics.draw(img.undyne_house,math.floor(resx()/2),0,0,scale()*2,scale()*2,img.undyne_house:getWidth()/2,0)
		love.graphics.draw(img["spr_undynehouse_fire_"..undyneframe],math.floor(resx()/2)-11*scale(),-44*scale(),0,scale()*2,scale()*2,img.spr_undynehouse_fire_0:getWidth()/2,0)
		
		
	end
	
	if bounds[mode] then
		-- box --
		love.graphics.print(name.."   LV 1",resx()/2-291*scale(),399*scale(),0,scale())
		love.graphics.draw(img.btn_fight,resx()/2-288*scale(),432*scale(),0,scale(),scale(),0,0)
		love.graphics.draw(img.btn_act,resx()/2-135*scale(),432*scale(),0,scale(),scale(),0,0)
		love.graphics.draw(img.btn_item,resx()/2+25*scale(),432*scale(),0,scale(),scale(),0,0)
		love.graphics.draw(img.btn_mercy,resx()/2+180*scale(),432*scale(),0,scale(),scale(),0,0)
		love.graphics.draw(img.health,resx()/2-76*scale(),400*scale(),0,scale(),scale(),0,0)
		if mode == "toriel" then
			love.graphics.draw(img.health_low,resx()/2-76*scale(),400*scale(),0,scale(),scale(),0,0)
			love.graphics.draw(img.box_toriel,resx()/2,200*scale(),0,scale(),scale(),img.box_toriel:getWidth()/2,0)
		elseif mode == "greaterdog" then
			love.graphics.draw(img.box_greaterdog,resx()/2,250*scale(),0,scale(),scale(),img.box_greaterdog:getWidth()/2,0)
		elseif mode == "asriel" then
			love.graphics.draw(img.box_asriel,resx()/2,250*scale(),0,scale(),scale(),img.box_asriel:getWidth()/2,0)
			r = math.max(math.sin(colortick2*math.pi*2/8*4/3),0.3)*255
			g = math.max(math.sin((colortick2-1)*math.pi*2/8*4/3),0.3)*255
			b = math.max(math.sin((colortick2+1)*math.pi*2/8*4/3),math.sin((colortick-3)*math.pi*2/8*4/3),0.3)*255
			love.graphics.setColor(r,g,b)
			love.graphics.draw(img.btn_save,resx()/2-135*scale(),432*scale(),0,scale(),scale(),0,0)
			love.graphics.setColor(255,255,255)
		end
	end
	
	-- entities --
	for k,v in pairs (ent) do
		if v.id == "drop" then
			love.graphics.setColor(255,255,255,255-v.tick*(255/0.7))
		else
			love.graphics.setColor(255,255,255)
		end
		if v.id == "z" then
			love.graphics.setColor(255,255,255,math.min(255*2-v.tick*255*2,255),0)
			s = math.min(v.tick*2,1)
			love.graphics.draw(img[v.id],resx()/2+(v.x+math.sin(v.tick*7)*15)*scale(),v.y*scale(),0,s*scale(),s*scale(),img[v.id]:getWidth()/2,img[v.id]:getHeight()/2)
		elseif v.id == "star" then
			love.graphics.setColor(255,255,255,200)
			s = 120/v.y/4+0.5
			love.graphics.draw(img["spr_twinklestar_"..v.frame],resx()/2+v.x*scale(),v.y*scale(),0,s*scale(),s*scale(),img.spr_twinklestar_0:getWidth()/2,img.spr_twinklestar_0:getHeight()/2)
			love.graphics.setColor(255,255,255)
		else
			love.graphics.draw(img[v.id],resx()/2+(v.x-camx)*scale(),(v.y+v.offy)*scale(),0,scale(),scale(),img[v.id]:getWidth()/2,img[v.id]:getHeight()/2)
		end
	end
	
	love.graphics.setColor(255,255,255)
	if mode == "toriel" then
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill",0,200*scale(),resx()/2-185/2*scale(),190*scale())
		love.graphics.rectangle("fill",resx()/2+185/2*scale(),200*scale(),resx()/2-185/2*scale(),190*scale())
		love.graphics.setColor(255,255,255)
		love.graphics.draw(img.toriel_grid,resx()/2-(106+198)*scale(),10*scale(),0,scale(),scale(),0,0)
		love.graphics.draw(img.toriel_grid,resx()/2+(106+198)*scale(),10*scale(),0,-scale(),scale(),0,0)
	elseif mode == "asriel" then
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill",0,250*scale(),resx()/2-315/2*scale(),140*scale())
		love.graphics.rectangle("fill",resx()/2+315/2*scale(),250*scale(),resx()/2-315/2*scale(),140*scale())
		love.graphics.setColor(255,255,255)
	elseif mode == "greaterdog" then
		love.graphics.draw(img["sleepingdog"..math.floor(wagtick)],resx()/2,363*scale(),0,scale(),scale(),img.sleepingdog1:getWidth()/2,0)
	end
	
	if bounds[mode] then
		-- heart --
		love.graphics.draw(img.heart,resx()/2+player.x*scale(),player.y*scale(),0,scale(),scale(),img.heart:getWidth()/2,img.heart:getHeight()/2)
	end
	
	-- debug --
	if debugmode then
		love.graphics.print("FPS: "..love.timer.getFPS(),0,0)
		love.graphics.print("Entities: "..#ent,0,30)
	end
	
end

function love.update(dt)
	
	-- player --
	if bounds[mode] then
		if love.keyboard.isDown("right") then
			player.x = math.min(player.x + 120 * dt, bounds[mode].w-5)
		end
		if love.keyboard.isDown("left") then
			player.x = math.max(player.x - 120 * dt, -bounds[mode].w+5)
		end
		if love.keyboard.isDown("down") then
			player.y = math.min(player.y + 120 * dt, 390-5)
		end
		if love.keyboard.isDown("up") then
			player.y = math.max(player.y - 120 * dt, 390-bounds[mode].h+5)
		end
	end
	
	-- entities --
	if spawndelay[mode] then
		spawntick = spawntick + dt
		if spawntick > spawndelay[mode] then
			spawntick = spawntick - spawndelay[mode]
			
			if mode == "toriel" then
				dir = math.random(0,1)*2-1
				if player.x < -185/2-5+50 then
					dir = 1
				elseif player.x > 185/2-5-50 then
					dir = -1
				end
				table.insert(ent,{id="fire",x=player.x+math.random(20,80)*dir,y=205,offy=0,dx=math.random(70,90)*dir,dy=math.random(110,150)})
			elseif mode == "asriel" then
				dir = math.random(0,1)*2-1
				if player.x < -315/2-5+50 then
					dir = 1
				elseif player.x > 315/2-5-50 then
					dir = -1
				end
				table.insert(ent,{id="fire",x=player.x+math.random(50,100)*dir,y=255,offy=0,dx=math.random(70,90)*dir,dy=math.random(110,150)})
			elseif mode == "statue" then
				table.insert(ent,{id="rain",x=math.random(-30,20),y=0,dx=0,dy=math.random(110,150),offy=0})
			elseif mode == "hotel" then
				if math.random(0,2) > 0 then
					table.insert(ent,{id="z",tick=0,x=55,y=math.random(1,3)*50+75,offy=0})
				end
			elseif mode == "waterfall" then
				table.insert(ent,{id="rain",x=math.random(-resx()/2/scale(),resx()/2/scale()+50)+camx,y=0,offy=math.random(-100,0),dx=0,dy=math.random(110,150)})
			end
			
		end
	end
	
	for k,v in pairs (ent) do
		if v.id == "fire" then
			if math.sqrt((v.x-player.x)^2+(v.y-player.y)^2) < 60 then
				if v.x > player.x then
					v.dx = 140
				else
					v.dx = -140
				end
				v.x = v.x + v.dx * dt
			else
				if v.x < bounds[mode].w-5 and v.x > -bounds[mode].w+5 then
					v.x = v.x + v.dx * dt
				end
			end
			v.dx = v.dx / (1 + dt)
			v.y = math.min(v.y + v.dy * dt, 390-5)
			if v.y >= 390-10 then
				table.remove(ent,k)
			end
		elseif v.id == "rain" then
			v.y = v.y + v.dy * dt
			v.dy = v.dy + 1000 * dt
			if (mode == "statue" and ((modemod == 0 and v.y >= 160) or (modemod == 1 and v.y >= 130))) or (mode == "waterfall" and v.y >= 350) then
				for f = 1,math.random(2,3) do
					table.insert(ent,{id="drop",tick=0,x=v.x,y=v.y,offy=v.offy,dx=math.random(-50,50),dy=-math.random(100,200)})
				end
				table.remove(ent,k)
			end
		elseif v.id == "drop" then
			v.x = v.x + v.dx * dt
			v.y = v.y + v.dy * dt
			v.dy = v.dy + 400 * dt
			v.tick = v.tick + dt
			if v.tick >= 0.7 then
				table.remove(ent,k)
			end
		elseif v.id == "z" then
			v.y = v.y - 60 * dt
			v.tick = v.tick + dt
			if v.tick >= 1 then
				table.remove(ent,k)
			end
		elseif v.id == "star" then
			v.tick = v.tick + dt
			if v.tick > 0.1 then
				v.tick = v.tick - 0.1
				v.frame = v.frame + 1
				if v.frame > 11 then
					v.frame = 0
				end
			end
		end
	end
	
	if mode == "greaterdog" then
		wagtick = wagtick + 3 * dt
		if wagtick >= 3 then
			wagtick = 1
		end
	elseif mode == "waterfall" then
		camx = camx + 100 * dt
		if camx > 1560/2 then
			camx = camx - 1560
			for k,v in pairs (ent) do
				if v.id == "rain" or v.id == "drop" then
					v.x = v.x - 1560
				end
			end
		end
		walktick = walktick + dt
		if walktick > 0.2 then
			walktick = walktick - 0.2
			walkframe = walkframe + 1
			if walkframe > 2 then
				walkframe = 1
			end
		end
		streamy = streamy + 200 * dt
		if streamy > 60 then
			streamy = streamy - 60
		end
	elseif mode == "asriel" then
		colortick = colortick + 2 * dt
		if colortick > 4 then
			colortick = colortick - 4
		end
		colortick2 = colortick2 + 5.5 * dt
		if colortick2 > 4 then
			colortick2 = colortick2 - 4
		end
		asrieltick = asrieltick + dt
		if asrieltick > 0.2 then
			asrieltick = asrieltick - 0.2
			asrielarmframe = asrielarmframe + 1
			if asrielarmframe > 3 then
				asrielarmframe = 0
			end
			asrielbodyframe = asrielbodyframe + 1
			if asrielbodyframe > 4 then
				asrielbodyframe = 0
			end
			asrielorbframe = asrielorbframe + 1
			if asrielorbframe > 2 then
				asrielorbframe = 0
			end
		end
		asrielwingpos = asrielwingpos - 50 * dt
		if asrielwingpos <= 0 then
			asrielwingpos = asrielwingpos + 800
		end
	elseif mode == "undynehouse" then
		undynetick = undynetick + dt
		if undynetick >= 0.17 then
			undynetick = undynetick - 0.17
			undyneframe = undyneframe + 1
			if undyneframe > 7 then
				undyneframe = 0
			end
		end
	end
	timepassed = timepassed + dt
	
end

function love.keypressed(k)
	
	if k == "f1" then
		for k,v in pairs (modes) do
			if v == mode then
				if k == #modes then
					mode = modes[1]
				else
					mode = modes[k+1]
				end
				break
			end
		end
		modemod = math.random(0,1)
		player.x = 0
		player.y = 320
		ent = {}
		timepassed = 0
		camx = 0
		spawntick = 0
		if mode == "castle" then
			for f = 1,65 do
				table.insert(ent,{id="star",x=math.random(-320,320),y=math.random(20,120),frame=math.random(0,11),tick=0})
			end
		end
	elseif k == "f2" then
		timepassed = timepassed + 120
	elseif k == "f3" then
		debugmode = not debugmode
	elseif k == "f4" then
		fullscreen = not fullscreen
		love.window.setMode(640,480,{fullscreen=fullscreen})
	elseif k ~= "left" and k ~= "right" and k ~= "up" and k ~= "down" then
		love.event.quit()
	end
	
end

function love.mousepressed()
	love.event.quit()
end
